#include <string.h>
#include <stdlib.h>
#include <stdbool.h>

struct Benutzer
{
  char benutzername[16];
  char eMailAdresse[16]; //z.B. a.mueller@abc.de
};
typedef struct Benutzer Benutzer;

Benutzer** findeAlleDoppeltenEMailAdressen(Benutzer b[], int anzahl, int *pEchteFaelle)
{
  int zahlFaelle = 0;
  for(int i = 0; i < anzahl - 1; i++)
  {
    for(int j = i + 1; j < anzahl; j++)
    {
      if(strcmp(b[i].eMailAdresse, b[j].eMailAdresse) == 0)
      {
        zahlFaelle++;
      }
    }
  }
  
  Benutzer **faelle = malloc(2 * zahlFaelle * sizeof (Benutzer *) );
  if(faelle == NULL)
  {
    // Speicherreservierung fehlgeschlagen
  }
  
  Benutzer **z = faelle;
  int echteFaelle = 0;
  
  for(int i = 0; i < anzahl - 1; i++)
  {
    for(int j = i + 1; j < anzahl; j++)
    {
      if(strcmp(b[i].eMailAdresse, b[j].eMailAdresse) == 0)
      {
        bool nochNicht = true;
        for(Benutzer **p = faelle; p < z; p++)
        {
          if(*p == b + i)
          {
            nochNicht = false;
            break;
          }
        }
        if(nochNicht)
        {
          *z = b + i;
          z++;
          echteFaelle++;
        }

        nochNicht = true;
        for(Benutzer **p = faelle; p < z; p++)
        {
          if(*p == b + j)
          {
            nochNicht = false;
            break;
          }
        }
        if(nochNicht)
        {        
          *z = b + j;
          z++;
          echteFaelle++;
        }
      }
    }
  } 
  
  *pEchteFaelle = echteFaelle;
  
  faelle = realloc(faelle, echteFaelle * sizeof (Benutzer *) );
  
  return faelle;
}

Benutzer benutzer[] = {{"Anton","anto3@67.qerqer"},
                       {"Berta","anton@wgw.qer"},
                       {"Carla","antonf@ghs.qer"},
                       {"Doris","anton@wgw.qer"},
                       {"Egon","anton@wgw.qer"},
                      };

int main( void )
{
  int zahl;
  Benutzer **ben = findeAlleDoppeltenEMailAdressen(benutzer, 5, &zahl);

  char c = ben[0]->benutzername[0];
  
  free(ben);
  
  return 0;
}
